# need to bootstrap first
%define enable_asymptote	0
%define enable_xindy		0

#in its own package.
%define enable_xdvik            0
%define enable_dvi2tty          0

%define with_system_poppler	0
%define with_system_dialog	1
%define with_system_lcdf	0
%define with_system_psutils	1
%define with_system_t1lib	1
%define with_system_tex4ht	0
%define with_system_teckit	0


%define texmfdir		%{_datadir}/texmf
%define texmfdistdir		%{_datadir}/texmf-dist

#-----------------------------------------------------------------------
Name:		texlive
Version:	20100722
Release:	%mkrel 35
Summary:	The TeX formatting system
Group:		Publishing
License:	Apache2 and Artistic and BSD and FDL and Freeware and GFL and GFSL and GPL and GPLv2 and GPLv3 and LGPL and LGPLv2.1 and LPPL and LPPLv1 and LPPLv1.2 and LPPLv1.3 and OFL and Public Domain
URL:		http://tug.org/texlive/
Source0:	ftp://tug.org/historic/systems/texlive/2010/texlive-20100722-source.tar.xz
Source1:	ftp://tug.org/historic/systems/texlive/2010/texlive-20100722-source.tar.xz.sha256
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

Obsoletes:	kpathsea <= 2007
Obsoletes:	pdfjam <= 1.21
Obsoletes:	tetex <= 3.1
Provides:       tetex  = %{version}-%{release}
Obsoletes:	tetex-context <= 3.1
Provides:	context = %{version}-%{release}
Obsoletes:	tetex-devel <= 3.1
Obsoletes:	tetex-dvipdfm <= 3.1
Provides:	dvipdfm = %{version}-%{release}
Obsoletes:	tetex-dvips <= 3.1
Provides:	dvips = %{version}-%{release}
Obsoletes:	tetex-mfwin <= 3.1
Provides:	mfwin = %{version}-%{release}
Obsoletes:	tetex-texi2html <= 3.1
Provides:	texi2html = %{version}-%{release}
Obsoletes:	tetex-usrlocal <= 3.1
Provides:	usrlocal = %{version}-%{release}
%if %{enable_xdvik}
Obsoletes:	tetex-xdvi <= 3.1
Provides:	xdvi = %{version}-%{release}
Obsoletes:      xdvi <= 22.86
Obsoletes:      texlive-xdvi <= 2007
%endif
Obsoletes:	texlive-afm <= 2007
Provides:	afm = %{version}-%{release}
Obsoletes:	texlive-context <= 2007
Obsoletes:	texlive-dvilj <= 2007
Obsoletes:	tetex-dvilj <= 3.0
Provides:	dvilj = %{version}-%{release}
Obsoletes:	texlive-dvipdfm <= 2007
Provides:	dvipdfm = %{version}-%{release}
Obsoletes:	texlive-dvips <= 2007
Obsoletes:      tetex-dvips <= 3.1
Provides:       tetex-dvips = %{version}-%{release}
Obsoletes:	texlive-dviutils <= 2007
Provides:	dviutils = %{version}-%{release}
Obsoletes:	texlive-latex <= 2007
Provides:       tetex-latex  = %{version}-%{release}
Provides:       latex = %{version}-%{release}
Obsoletes:      tetex-latex <= 3.1
Obsoletes:	texlive-mfwin <= 2007
Obsoletes:	texlive-fonts <= 2007

#-----------------------------------------------------------------------
%if %{with_system_dialog}
Requires:	cdialog
%endif
Requires:	ghostscript
%if %{with_system_lcdf}
Requires:	lcdf-typetoools
%else
Provides:	lcdf-typetools = %{version}
Obsoletes:	lcdf-typetools <= 2.59-5
%endif
%if %{with_system_psutils}
Requires:	psutils
%endif
%if %{with_system_teckit}
Requires:	teckit
%endif
%if %{with_system_tex4ht}
Requires:	tex4ht
%else
Provides:	tex4ht = %{version}
Obsoletes:	tex4ht <= 1:1.0.2008_02_28_2058
%endif
Requires(post):	texlive-texmf

#-----------------------------------------------------------------------
BuildRequires:	bison
%if %{enable_xindy}
BuildRequires:	clisp
BuildRequires:	ffcall-devel
%endif
%if %{enable_asymptote}
BuildRequires:	fftw-devel
BuildRequires:	flex
%endif
BuildRequires:	freetype-devel
BuildRequires:	fontconfig-devel
BuildRequires:	gd-devel
%if %{enable_asymptote}
BuildRequires:	libgc-devel
BuildRequires:	libsigsegv-devel
BuildRequires:	ghostscript-dvipdf
BuildRequires:	gsl-devel
BuildRequires:	GL-devel
%endif
BuildRequires:	libgd-devel
%if %{with_system_poppler}
BuildRequires:	libpoppler-devel
%endif
BuildRequires:	libxaw-devel
%if !%{with_system_dialog}
BuildRequires:	ncurses-devel
%endif
BuildRequires:	png-devel
%if %{with_system_t1lib}
BuildRequires:	t1lib-devel
%endif
%if %{with_system_teckit}
BuildRequires:	teckit-devel
%endif
%if %{enable_xindy}
BuildRequires:	texlive
%endif
%if %{enable_asymptote}
BuildRequires:	texinfo
%endif
BuildRequires:	zziplib-devel

#-----------------------------------------------------------------------
Patch0:		texlive-20100722-underlink.patch
Patch1:		texlive-20100722-format.patch
Patch2:		texlive-20100722-asymptote.patch
Patch3:		texlive-icu-4.4-arm_asm.patch
#-----------------------------------------------------------------------
%description
TeX Live is an easy way to get up and running with the TeX document
production system. It provides a comprehensive TeX system. It includes
all the major TeX-related programs, macro packages, and fonts that are
free software, including support for many languages around the world.

%files
%defattr(-,root,root,-)
%{_bindir}/*
%dir %{_localstatedir}/lib/texmf
%dir %{_sysconfdir}/texmf

#-----------------------------------------------------------------------
%prep
%setup -q -n %{name}-%{version}-source
%patch0	-p1
%patch1	-p1
%if %{enable_asymptote}
%patch2 -p1
%endif
%patch3 -p1

# setup default builtin values, added to paths.h from texmf.cnf
perl -pi -e 's%^(TEXMFMAIN\s+= ).*%$1%{texmfdir}%;'			  \
	 -e 's%^(TEXMFDIST\s+= ).*%$1%{texmfdistdir}%;'			  \
	 -e 's%^(TEXMFLOCAL\s+= ).*%$1%{texmfdir}%;'			  \
	 -e 's%^(TEXMFSYSVAR\s+= ).*%$1%{_localstatedir}/lib/texmf%;'	  \
	 -e 's%^(TEXMFSYSCONFIG\s+= ).*%$1%{_sysconfdir}/texmf%;'	  \
	 -e 's%^(TEXMFHOME\s+= ).*%$1\{\$HOME/texmf,%{texmfdir}\}%;'	  \
	 -e 's%^(TEXMFVAR\s+= ).*%$1\$HOME/.texlive2010/texmf-var%;'	  \
	 -e 's%^(TEXMFCONFIG\s+= ).*%$1\$HOME/.texlive2010/texmf-config%;'\
	 -e 's%^(OSFONTDIR\s+= ).*%$1%{_datadir}/fonts%;'		  \
	texk/kpathsea/texmf.cnf

#-----------------------------------------------------------------------
%build
%configure2_5x							\
	--with-banner-add="/Mageia"				\
	--disable-native-texlive-build				\
	--enable-missing					\
%if %{enable_xindy}
	--enable-xindy						\
%else
	--disable-xindy						\
%endif
%if %{enable_xdvik}
        --enable-xdvik                                          \
%else
        --disable-xdvik                                         \
%endif
%if %{enable_dvi2tty}
        --enable-dvi2tty                                        \
%else
        --disable-dvi2tty                                       \
%endif
	--with-system-freetype					\
	--with-freetype-includes=%{_includedir}/freetype	\
	--with-system-freetype2					\
	--with-freetype2-includes=%{_includedir}/freetype2	\
%if %{with_system_dialog}
	--disable-dialog					\
%else
	--enable-dialog						\
%endif
%if %{with_system_psutils}
	--disable-psutils					\
%else
	--enable-psutils					\
%endif
	--with-system-gd					\
%if %{with_system_lcdf}
	--disable-lcdf-typetools				\
%endif
	--with-system-png					\
%if %{with_system_t1lib}
	--with-system-t1lib					\
	--disable-t1utils					\
%endif
%if %{with_system_teckit}
	--disable-teckit					\
	--with-teckit-includes=%{_includedir}/teckit		\
%endif
%if %{with_system_tex4ht}
	--disable-tex4htk					\
%endif
%if %{with_system_poppler}
	--with-system-xpdf					\
%else
	--without-system-xpdf					\
%endif
	--with-system-zziplib
%make

%if %{enable_asymptote}
pushd utils/asymptote
%configure2_5x							\
	--enable-gc=system					\
	--enable-texlive-build					\
	--datadir=%{texmfdir}
%make
popd
%endif

#-----------------------------------------------------------------------
%install
%makeinstall_std

%if %{enable_asymptote}
pushd utils/asymptote
%makeinstall_std
popd
%endif

mkdir -p %{buildroot}%{_datadir}
for dir in texmf texmf-dist; do
    if [ -d %{buildroot}%{_prefix}/$dir ]; then
	rm -fr %{buildroot}%{_datadir}/$dir
	mv %{buildroot}%{_prefix}/$dir %{buildroot}%{_datadir}
    fi
done

mkdir -p %{buildroot}%{_localstatedir}/lib/texmf
mkdir -p %{buildroot}%{_sysconfdir}/texmf

%if %{with_system_lcdf}
# stray directory left
rm -fr %{buildroot}%{_datadir}/lcdf-typetools-for-tex-live
%else
# openmpi has a program with the same name
if [ -f %{buildroot}%{_bindir}/otfinfo ]; then
    mv -f %{buildroot}%{_bindir}/otfinfo{,-texlive}
fi
%endif

pushd %{buildroot}%{_bindir}
    # missing symbolic links
    ln -sf aleph lamed
    ln -sf luatex dvilualatex
    ln -sf luatex lualatex
    ln -sf luatex dviluatex
    ln -sf pdftex amstex
    ln -sf pdftex cslatex
    ln -sf pdftex csplain
    ln -sf pdftex eplain
    ln -sf pdftex etex
    ln -sf pdftex latex
    ln -sf pdftex mex
    ln -sf pdftex mltex
    ln -sf pdftex mllatex
    ln -sf pdftex pdfcslatex
    ln -sf pdftex pdfcsplain
    ln -sf pdftex pdfetex
    ln -sf pdftex pdflatex
    ln -sf pdftex pdfmex
    ln -sf pdftex physe
    ln -sf pdftex phyzzx
    ln -sf pdftex utf8mex
    ln -sf pdftex texsis
    ln -sf ptex platex
    ln -sf mpost metafun
    ln -sf mpost mfplain
    ln -sf xetex xelatex
    # correct symlinks
    for file in *; do
	link=`readlink $file` || :
	if [ "x$link" != "x" ]; then
	    ln -sf `echo $link | sed -e 's%../%../share/%'` $file
	fi
    done
%if %{with_system_dialog}
    ln -sf dialog tcdialog
%endif
    rm -f a2ping
    rm -f e2pall
    rm -f rungs
    rm -f simpdftex
    rm -f tlmgr
    rm -f texdoc
    rm -f texdoctk
popd

# use texmf data
rm -fr %{buildroot}%{texmfdir} %{buildroot}%{texmfdistdir}

# install manual pages and info files from texlive-texmf tarball
rm -fr %{buildroot}%{_mandir} %{buildroot}%{_infodir}

# do not generate dynamic libraries and do not install static ones
rm -fr %{buildroot}%{_libdir}
rm -fr %{buildroot}%{_includedir}

#-----------------------------------------------------------------------
%clean
rm -rf %{buildroot}

#-----------------------------------------------------------------------
%posttrans
[ -x %{_bindir}/texconfig-sys ] && %{_bindir}/texconfig-sys rehash 2> /dev/null
[ -x %{_bindir}/fmtutil-sys ] && %{_bindir}/fmtutil-sys --all &> /dev/null
[ -x %{_bindir}/updmap-sys ] && %{_bindir}/updmap-sys --syncwithtrees &> /dev/null


%changelog
* Wed May 11 2011 ahmad <ahmad> 20100722-35.mga1
+ Revision: 97324
- Drop the %%postun scriptlet, it doesn't make sense to run '%%{_bindir}/texconfig-sys rehash'
  when uninstalling texlive:
  o if %%postun is used, it won't work as %%{_bindir}/texconfig-sys won't exist
    _after_ the package is uninstalled
  o if %%preun is used, %%{_bindir}/texconfig-sys will be executed, but the config
    is invalid as the texlive files are gone after it's uninstalled
  We can just rely on the %%posttrans scriptlets refreshing the config when reinstalling
  texlive.

* Mon Apr 18 2011 ahmad <ahmad> 20100722-34.mga1
+ Revision: 87811
- Use a more refined %%posttrans scriptlet (Fedora)
- Add a %%postun scriptlet to rebuild ls-R files

* Mon Apr 11 2011 dmorgan <dmorgan> 20100722-33.mga1
+ Revision: 83102
- Do not build dvi2tty

* Mon Apr 11 2011 dmorgan <dmorgan> 20100722-32.mga1
+ Revision: 83077
- Fix obsoletes
- Fix switch
- Fix switch

* Mon Apr 11 2011 dmorgan <dmorgan> 20100722-31.mga1
+ Revision: 83071
- Disable xdvik
  Obsolete xdvi

* Tue Mar 29 2011 dmorgan <dmorgan> 20100722-30.mga1
+ Revision: 78671
- Redirect posttrans output to /dev/null - only print messages sent to stderr

* Thu Mar 24 2011 dmorgan <dmorgan> 20100722-29.mga1
+ Revision: 76657
- More obsolete to ease upgrade

* Sat Mar 19 2011 dmorgan <dmorgan> 20100722-28.mga1
+ Revision: 74534
- jadetex and xmltex are in its own package so do not package them here
- Revert the split in current/ will be done in branch
- Fix macros
- Fix file list
  Sync with fedora ( we will have some sub packages
  Enable kpathsea
- Try to split texlive into subpackages

  + rtp <rtp>
    - backport icu arm fix from icu upstream ticket 7664 (bad asm syntax)

* Sat Mar 05 2011 dmorgan <dmorgan> 20100722-27.mga1
+ Revision: 64889
- Provide tetex and tetex-latex

* Fri Mar 04 2011 boklm <boklm> 20100722-26.mga1
+ Revision: 64155
- Obsoletes tetex-dvilj

* Fri Mar 04 2011 boklm <boklm> 20100722-25.mga1
+ Revision: 64047
- add provides on latex, dvips, dvipdf, etc ...

* Thu Mar 03 2011 dmorgan <dmorgan> 20100722-24.mga1
+ Revision: 63759
- Fix update from mdv

* Wed Mar 02 2011 dmorgan <dmorgan> 20100722-23.mga1
+ Revision: 62487
- Provides/Obsoletes jadetex

* Wed Mar 02 2011 dmorgan <dmorgan> 20100722-22.mga1
+ Revision: 62480
- Revert to last working state

* Wed Mar 02 2011 dmorgan <dmorgan> 20100722-21.mga1
+ Revision: 62455
- Do not use binary payload

* Wed Mar 02 2011 dmorgan <dmorgan> 20100722-20.mga1
+ Revision: 62420
- Merge mdv commit : 641198
  	- Change license tag to point to license file
  	- Add basic infrastructure to allow test installs with tetex
  	  on older distro releases
  	- Add gv as requires (default ps viewer for asymptote)

* Tue Mar 01 2011 dmorgan <dmorgan> 20100722-19.mga1
+ Revision: 62125
- Remove bootstrap

* Tue Mar 01 2011 dmorgan <dmorgan> 20100722-18.mga1
+ Revision: 61945
- Merge mdv commit  640010
  Add a simple patch to avoid attempting to be too smart, and
  still failing about X resources
- Correct xasy symlink

* Tue Mar 01 2011 dmorgan <dmorgan> 20100722-17.mga1
+ Revision: 61935
- Use jadetex from texlive instead

* Tue Mar 01 2011 dmorgan <dmorgan> 20100722-15.mga1
+ Revision: 61907
- Do not obsolete jadetex, it will come in its own package

* Tue Mar 01 2011 dmorgan <dmorgan> 20100722-14.mga1
+ Revision: 61902
- Fix obsolete

* Mon Feb 28 2011 dmorgan <dmorgan> 20100722-13.mga1
+ Revision: 61580
- Add missing provides

* Mon Feb 28 2011 dmorgan <dmorgan> 20100722-12.mga1
+ Revision: 61393
- Fix obsolete of xmltex

* Mon Feb 28 2011 dmorgan <dmorgan> 20100722-11.mga1
+ Revision: 61392
- Fix obsoletes
- Bootstrap xindy
- Disable bootstrap

  + boklm <boklm>
    - Obsoletes texlive-fonts

* Fri Feb 25 2011 dmorgan <dmorgan> 20100722-8.mga1
+ Revision: 59513
- Bootstrap
- Sync with mdv
- Remove old patches
- imported package texlive

